// Learn cc.Class:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] https://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {

    },
    onLoad() {

        this._done = false
    },


    // 修改文本使用的材质里effect记录的BlendFunc为ONE

    //  关联
    //https://forum.cocos.com/t/60-rmb-2-1-2/82293/40

    _setBlendFun() {

        if (this.node.getComponent(cc.Label)) {
            let material = this.node.getComponent(cc.Label).sharedMaterials[0]
            let passes = material._effect.getDefaultTechnique().passes;
            for (let j = 0; j < passes.length; j++) {
                let pass = passes[j];
                pass.setBlend(
                    true,
                    cc.gfx.BLEND_FUNC_ADD,
                    cc.gfx.BLEND_ONE, cc.gfx.BLEND_ONE_MINUS_SRC_ALPHA,
                    cc.gfx.BLEND_FUNC_ADD,
                    cc.gfx.BLEND_ONE, cc.gfx.BLEND_ONE_MINUS_SRC_ALPHA
                );
            }

            material.setDirty(true);
            return true
        }

    },

    update(dt) {

        if (!this._done) {
            this._done = this._setBlendFun()
        }


    },
});
